# Copyright (C) 2009-2011  Red Hat, Inc.
#
# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements.  See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.  The
# ASF licenses this file to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance with the
# License.  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
# License for the specific language governing permissions and limitations
# under the License.
#

module DeltaCloud
  module TestHelper

    include Test::Unit::Assertions

    API_URL   = "http://localhost:3001/api"
    API_USER  = "mockuser"
    API_PASWD = "mockpassword"

    def base_client(args)
      `bin/deltacloudc #{args}`
    end

    def client(args)
      args = "-u http://mockuser:mockpassword@localhost:3001/api " + args
      base_client(args)
    end

    def assert_no_warning(output)
      assert_no_match /\[WARNING\] Method unsupported by API: '(\w+)'/, output
    end

  end
end
